Merge pull request #505 from roji/shutdown_flow
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve gc-descriptors
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         bug-2907.cs             \
48         array-init.cs           \
49         arraylist.cs            \
50         assemblyresolve_event.cs        \
51         assemblyresolve_event3.cs       \
52         checked.cs              \
53         char-isnumber.cs        \
54         create-instance.cs      \
55         field-layout.cs         \
56         pack-layout.cs          \
57         pack-bug.cs             \
58         hash-table.cs           \
59         test-ops.cs             \
60         obj.cs                  \
61         test-dup-mp.cs          \
62         string.cs               \
63         stringbuilder.cs        \
64         switch.cs               \
65         outparm.cs              \
66         delegate.cs             \
67         bitconverter.cs         \
68         exception.cs            \
69         exception2.cs           \
70         exception3.cs           \
71         exception4.cs           \
72         exception5.cs           \
73         exception6.cs           \
74         exception7.cs           \
75         exception8.cs           \
76         exception10.cs          \
77         exception11.cs          \
78         exception12.cs          \
79         exception13.cs          \
80         exception14.cs          \
81         exception15.cs          \
82         exception16.cs          \
83         exception17.cs          \
84         typeload-unaligned.cs   \
85         struct.cs               \
86         valuetype-gettype.cs    \
87         typeof-ptr.cs           \
88         static-constructor.cs   \
89         pinvoke.cs              \
90         pinvoke2.cs             \
91         pinvoke3.cs             \
92         pinvoke11.cs            \
93         pinvoke13.cs            \
94         pinvoke17.cs            \
95         invoke.cs               \
96         invoke2.cs              \
97         runtime-invoke.cs               \
98         invoke-string-ctors.cs          \
99         reinit.cs               \
100         box.cs                  \
101         array.cs                \
102         enum.cs                 \
103         enum2.cs                \
104         property.cs             \
105         enumcast.cs             \
106         assignable-tests.cs     \
107         array-cast.cs           \
108         array-subtype-attr.cs   \
109         cattr-compile.cs        \
110         cattr-field.cs          \
111         cattr-object.cs         \
112         custom-attr.cs          \
113         double-cast.cs          \
114         newobj-valuetype.cs     \
115         arraylist-clone.cs      \
116         setenv.cs               \
117         vtype.cs                \
118         isvaluetype.cs          \
119         iface6.cs               \
120         iface7.cs               \
121         ipaddress.cs            \
122         array-vt.cs             \
123         interface1.cs           \
124         reflection-enum.cs      \
125         reflection-prop.cs      \
126         reflection4.cs          \
127         reflection5.cs          \
128         reflection-const-field.cs \
129         many-locals.cs          \
130         string-compare.cs       \
131         test-prime.cs           \
132         params.cs               \
133         reflection.cs           \
134         interface.cs            \
135         iface.cs                \
136         iface2.cs               \
137         iface3.cs               \
138         iface4.cs               \
139         iface-large.cs          \
140         virtual-method.cs       \
141         intptrcast.cs           \
142         indexer.cs              \
143         stream.cs               \
144         console.cs              \
145         shift.cs                \
146         jit-int.cs              \
147         jit-uint.cs             \
148         jit-long.cs             \
149         long.cs                 \
150         jit-ulong.cs            \
151         jit-float.cs            \
152         pop.cs                  \
153         time.cs                 \
154         appdomain.cs        \
155         appdomain1.cs           \
156         appdomain2.cs           \
157         appdomain-client.cs     \
158         appdomain-unload.cs \
159         appdomain-async-invoke.cs       \
160         loader.cs       \
161         pointer.cs              \
162         hashcode.cs             \
163         delegate1.cs            \
164         delegate2.cs            \
165         delegate3.cs            \
166         delegate5.cs            \
167         delegate6.cs            \
168         delegate7.cs            \
169         delegate8.cs            \
170         delegate9.cs            \
171         remoting1.cs            \
172         remoting2.cs            \
173         remoting3.cs            \
174         remoting4.cs            \
175         remoting5.cs            \
176         largeexp.cs             \
177         largeexp2.cs            \
178         marshalbyref1.cs        \
179         static-ctor.cs          \
180         inctest.cs              \
181         bound.cs                \
182         array-invoke.cs         \
183         test-arr.cs             \
184         decimal.cs              \
185         decimal-array.cs        \
186         marshal.cs              \
187         marshal1.cs             \
188         marshal2.cs             \
189         marshal3.cs             \
190         marshal5.cs             \
191         marshal6.cs             \
192         marshal7.cs             \
193         marshal8.cs             \
194         marshal9.cs             \
195         marshalbool.cs          \
196         marshal-valuetypes.cs   \
197         test-byval-in-struct.cs \
198         thread.cs               \
199         thread5.cs              \
200         thread6.cs              \
201         thread-static.cs        \
202         thread-static-init.cs   \
203         context-static.cs       \
204         float-pop.cs            \
205         interfacecast.cs        \
206         array3.cs               \
207         classinit.cs            \
208         classinit2.cs           \
209         synchronized.cs         \
210         async_read.cs           \
211         threadpool.cs           \
212         threadpool1.cs          \
213         threadpool-exceptions1.cs \
214         threadpool-exceptions2.cs \
215         threadpool-exceptions3.cs \
216         threadpool-exceptions4.cs \
217         threadpool-exceptions5.cs \
218         threadpool-exceptions6.cs \
219         threadpool-exceptions7.cs \
220         base-definition.cs      \
221         bug-27420.cs            \
222         bug-47295.cs            \
223         bug-46781.cs            \
224         bug-48015.cs            \
225         bug-42136.cs            \
226         bug-59286.cs            \
227         bug-70561.cs            \
228         bug-78311.cs            \
229         bug-78653.cs            \
230         bug-78656.cs            \
231         bug-77127.cs            \
232         bug-323114.cs           \
233         bug-Xamarin-5278.cs     \
234         interlocked.cs          \
235         cross-domain.cs         \
236         appdomain-exit.cs       \
237         delegate-async-exit.cs  \
238         delegate-delegate-exit.cs       \
239         delegate-exit.cs        \
240         finalizer-abort.cs      \
241         finalizer-exception.cs  \
242         finalizer-exit.cs       \
243         finalizer-thread.cs     \
244         main-exit.cs    \
245         main-returns-abort-resetabort.cs        \
246         main-returns-background-abort-resetabort.cs     \
247         main-returns-background-resetabort.cs   \
248         main-returns-background.cs      \
249         main-returns-background-change.cs       \
250         main-returns.cs         \
251         subthread-exit.cs       \
252         desweak.cs              \
253         cominterop.cs           \
254         exists.cs               \
255         handleref.cs    \
256         transparentproxy.cs \
257         dbnull-missing.cs       \
258         test-type-ctor.cs       \
259         soft-float-tests.cs     \
260         thread-exit.cs          \
261         finalize-parent.cs      \
262         assemblyresolve_event2.2.cs     \
263         interlocked-2.2.cs      \
264         pinvoke-2.2.cs          \
265         bug-78431.2.cs          \
266         bug-79684.2.cs          \
267         catch-generics.2.cs     \
268         event-get.2.cs          \
269         safehandle.2.cs         \
270         stackframes-async.2.cs          \
271         module-cctor-loader.2.cs        \
272         generics-invoke-byref.2.cs      \
273         generic-signature-compare.2.cs  \
274         generics-sharing.2.cs   \
275         shared-generic-methods.2.cs     \
276         shared-generic-synchronized.2.cs        \
277         generic-inlining.2.cs   \
278         generic-initobj.2.cs    \
279         generic-delegate.2.cs   \
280         generic-sizeof.2.cs     \
281         generic-virtual.2.cs    \
282         generic-interface-methods.2.cs  \
283         generic-array-type.2.cs \
284         generic-method-patching.2.cs    \
285         generic-static-methods.2.cs     \
286         generic-null-call.2.cs  \
287         generic-special.2.cs    \
288         generic-exceptions.2.cs \
289         generic-virtual2.2.cs   \
290         generic-valuetype-interface.2.cs        \
291         generic-getgenericarguments.2.cs        \
292         generic-type-builder.2.cs       \
293         generic-synchronized.2.cs       \
294         generic-delegate-ctor.2.cs      \
295         generic-array-iface-set.2.cs    \
296         generic-typedef.2.cs    \
297         generic-marshalbyref.2.cs       \
298         generic-xdomain.2.cs    \
299         bug-431413.2.cs \
300         bug-459285.2.cs \
301         generic-virtual-invoke.2.cs     \
302         bug-461198.2.cs \
303         generic-sealed-virtual.2.cs     \
304         generic-system-arrays.2.cs      \
305         generic-stack-traces.2.cs       \
306         generic-stack-traces2.2.cs      \
307         bug-472600.2.cs \
308         recursive-generics.2.cs \
309         bug-473482.2.cs \
310         bug-473999.2.cs \
311         bug-479763.2.cs \
312         bug-616463.cs   \
313         bug-80392.2.cs          \
314         dynamic-method-access.2.cs      \
315         dynamic-method-finalize.2.cs    \
316         bug-82194.2.cs  \
317         anonarray.2.cs  \
318         ienumerator-interfaces.2.cs     \
319         array-enumerator-ifaces.2.cs    \
320         generic_type_definition_encoding.2.cs \
321         generic_type_definition.2.cs    \
322         bug-333798.2.cs         \
323         bug-333798-tb.2.cs              \
324         bug-335131.2.cs         \
325         bug-322722_patch_bx.2.cs                \
326         bug-348522.2.cs         \
327         bug-340662_bug.cs       \
328         bug-322722_dyn_method_throw.2.cs        \
329         bug-389886-2.cs \
330         bug-325283.2.cs \
331         thunks.cs \
332         winx64structs.cs \
333         bug-349190.2.cs \
334         nullable_boxing.2.cs    \
335         valuetype-equals.cs     \
336         custom-modifiers.2.cs   \
337         bug-382986.cs   \
338         test-inline-call-stack.cs       \
339         bug-324535.cs   \
340         modules.cs      \
341         bug-81673.cs    \
342         bug-81691.cs    \
343         bug-80307.cs    \
344         bug-415577.cs   \
345         filter-stack.cs \
346         vararg2.cs      \
347         bug-389886-sre-generic-interface-instances.cs   \
348         bug-461867.cs   \
349         bug-461941.cs   \
350         bug-461261.cs   \
351         bug-400716.cs   \
352         bug-462592.cs   \
353         bug-459094.cs   \
354         generic-unloading.2.cs  \
355         generic-unloading-sub.2.cs      \
356         bug-467456.cs   \
357         appdomain-unload-callback.cs    \
358         bug-508538.cs   \
359         bug-472692.2.cs         \
360         gchandles.cs    \
361         interlocked-3.cs        \
362         interlocked-4.2.cs      \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs     \
386         async-with-cb-throws.cs \
387         appdomain-unload-doesnot-raise-pending-events.cs        \
388         bug-6148.cs     \
389         assembly_append_ordering.cs     \
390         bug-10127.cs    \
391         allow-synchronous-major.cs
392
393 TEST_CS_SRC_DIST=       \
394         $(BASE_TEST_CS_SRC)     \
395         async-exc-compilation.cs \
396         filter-stack.cs \
397         finally_guard.cs
398
399 TEST_CS_SRC_GEN = \
400         runtime-invoke.gen.cs \
401         imt_big_iface_test.cs
402
403 if AMD64
404 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
405 # #651684
406 PLATFORM_DISABLED_TESTS = finally_guard.exe
407 else
408 if X86
409 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
410 else
411 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
412 endif
413 endif
414
415 if IA64
416 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
417 # bug #319249
418 PLATFORM_DISABLED_TESTS=exception17.exe
419 PLATFORM_DISABLED_TESTS+=winx64structs.exe
420 endif
421
422 if X86
423
424 if HOST_WIN32
425 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
426 endif
427
428 endif
429
430 if POWERPC
431 # bug #71274
432 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
433 endif
434
435 if ARM
436 PLATFORM_DISABLED_TESTS=filter-stack.exe
437 endif
438
439 if MIPS
440 # monitor.exe is racy
441 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
442 endif
443
444 if S390x
445 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
446 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
447 endif
448
449 # bug-459094.exe creates an extremely deep directory tree
450 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
451 # reverted.
452 DISABLED_TESTS=                 \
453         delegate-async-exception.exe    \
454         bug-348522.2.exe        \
455         bug-459094.exe \
456         delegate-invoke.exe \
457         $(PLATFORM_DISABLED_TESTS)
458
459 DISABLED_TESTS_WRENCH=  \
460         $(DISABLED_TESTS)       \
461         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
462         main-returns-background-resetabort.exe \
463         main-returns-background-abort-resetabort.exe    \
464         main-returns-background.exe     \
465         thread6.exe     \
466         assemblyresolve_event3.exe \
467         delegate2.exe   \
468         finally_guard.exe       \
469         finalizer-abort.exe     \
470         finalizer-exit.exe      \
471         finalizer-thread.exe \
472         appdomain-async-invoke.exe
473
474 AOT_DISABLED_TESTS=constraints-load.exe
475
476 # These only compile with MS CSC
477 TEST_CSC_SRC=                   \
478         vararg.cs
479
480 TEST_IL_SRC=                    \
481         field-access.il         \
482         method-access.il        \
483         ldftn-access.il         \
484         cpblkTest.il            \
485         vbinterface.il          \
486         calliTest.il            \
487         ckfiniteTest.il         \
488         fault-handler.il                \
489         locallocTest.il         \
490         initblkTest.il          \
491         qt-instance.il          \
492         vararg.il               \
493         bug-29859.il            \
494         bug-78549.il            \
495         static-fields-nonconst.il       \
496         reload-at-bb-end.il     \
497         test-enum-indstoreil.il \
498         filter-bug.il           \
499         even-odd.il             \
500         bug-82022.il    \
501         vt-sync-method.il       \
502         enum_types.il   \
503         invalid-token.il        \
504         call_missing_method.il  \
505         call_missing_class.il   \
506         ldfld_missing_field.il  \
507         ldfld_missing_class.il  \
508         find-method.2.il        \
509         bug-79215.2.il  \
510         bug-79956.2.il  \
511         bug-327438.2.il \
512         bug-387274.2.il \
513         bug-426309.2.il \
514         ldtoken_with_byref_typespec.2.il \
515         resolve_method_bug.2.il \
516         resolve_field_bug.2.il \
517         resolve_type_bug.2.il   \
518         generics-sharing-other-exc.2.il \
519         generic-ldobj.2.il      \
520         generic-mkrefany.2.il   \
521         generic-refanyval.2.il  \
522         generic-ldtoken.2.il    \
523         generic-ldtoken-method.2.il     \
524         generic-ldtoken-field.2.il      \
525         generic-tailcall.2.il   \
526         generic-tailcall2.2.il  \
527         generic-array-exc.2.il  \
528         generic-valuetype-newobj2.2.il  \
529         generic-valuetype-newobj.2.il   \
530         generic-constrained.2.il        \
531         generic-type-load-exception.2.il        \
532         bug-81466.il    \
533         bug457574.il    \
534         bug445361.il    \
535         bug-463303.il   \
536         bug469742.2.il  \
537         bug-528055.il   \
538         constraints-load.il     \
539         array_load_exception.il \
540         bug-481403.il   \
541         interface-with-static-method.il \
542         bug-515884.il   \
543         bug-633291.il   \
544         delegate-with-null-target.il    \
545         bug-318677.il   \
546         gsharing-valuetype-layout.il    \
547         invalid_generic_instantiation.il
548
549
550 # pre-requisite test sources: files that are not test themselves
551 # but that need to be compiled
552 PREREQ_IL_SRC=event-il.il module-cctor.il
553 PREREQ_CS_SRC=
554 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
555 PREREQ_CS_DLL_SRC=
556
557 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
558 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
559 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
560 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
561 TESTBS=$(BENCHSRC:.cs=.exe)
562 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
563
564 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
565         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
566
567 %.exe: %.il
568         $(ILASM) -out:$@ $<
569
570 %.exe: %.cs TestDriver.dll
571         $(MCS) -r:TestDriver.dll -out:$@ $<
572
573 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
574 if POWERPC
575 test_platform:
576 else
577 # Can't use mkbundle on win32 since there is no static build there
578 # Can't run test-unhandled-exception on Windows because of all the debug popups...
579 if HOST_WIN32
580 test_platform:
581 else
582 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
583 #test_platform: testbundle test-iomap-regression
584 test_platform:  test-iomap-regression
585 endif
586 endif
587
588 if X86
589 if HOST_WIN32
590 else
591 test_platform: test-eglib-remap
592 endif
593 endif
594
595 # Target to precompile the test executables
596 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
597
598 #
599 # Test that no symbols are missed in eglib-remap.h
600 #
601 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
602 test-eglib-remap:
603         @echo "Testing eglib remap..."
604         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
605
606 #
607 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
608 # code that checks that the table is properly sorted
609 #
610 test-messages: w32message.exe
611         > test_messages.zero
612         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
613
614 if MOONLIGHT
615 test_2_1 : test-coreclr-security
616 else
617 test_2_1 :
618 endif
619
620 if AMD64
621 test-sgen : sgen-tests
622 else
623 if X86
624 test-sgen : sgen-tests
625 else
626 if ARM
627 test-sgen : sgen-tests
628 else
629 if S390x
630 test-sgen : sgen-regular-tests
631 endif
632 endif
633 endif
634 endif
635
636 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
637 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
638
639 # Remove empty .stdout and .stderr files for wrench
640 rm-empty-logs:
641         @echo "Removing empty logs..."
642         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
643
644 assemblyresolve/test/asm.dll:
645         $(MAKE) -C assemblyresolve prereq
646
647 TestDriver.dll:
648         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
649
650 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
651         @failed=0; \
652         passed=0; \
653         for i in $(TESTSI_CS); do       \
654                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
655                 then \
656                         passed=`expr $${passed} + 1`; \
657                 else \
658                         if [ $$? = 2 ]; then break; fi; \
659                         failed=`expr $${failed} + 1`; \
660                 fi \
661         done; \
662         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
663
664 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
665         @failed=0; \
666         passed=0; \
667         for i in $(TESTSI_IL); do       \
668                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" 'no-dump' $(RUNTIME_ARGS); \
669                 then \
670                         passed=`expr $${passed} + 1`; \
671                 else \
672                         if [ $$? = 2 ]; then break; fi; \
673                         failed=`expr $${failed} + 1`; \
674                 fi \
675         done; \
676         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
677
678 testb: $(TEST_PROG) $(TESTBS)
679         for i in $(TESTBS); do  \
680                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS);   \
681         done
682
683 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
684         @failed=0; \
685         passed=0; \
686         failed_tests="";\
687         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
688                 rm -f $${i}.so; \
689                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
690                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' 'dump-output' $(RUNTIME_ARGS); \
691                 then \
692                         passed=`expr $${passed} + 1`; \
693                 else \
694                         if [ $$? = 2 ]; then break; fi; \
695                         failed=`expr $${failed} + 1`; \
696                         failed_tests="$${failed_tests} $$i"; \
697                 fi \
698         done; \
699         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
700         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
701           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
702
703 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
704         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
705
706 testjit-wrench:
707         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
708
709 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
710         @failed=0; \
711         passed=0; \
712         failed_tests="";\
713         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
714                 rm -f $${i}.so; \
715                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
716                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
717                 then \
718                         passed=`expr $${passed} + 1`; \
719                 else \
720                         if [ $$? = 2 ]; then break; fi; \
721                         failed=`expr $${failed} + 1`; \
722                         failed_tests="$${failed_tests} $$i"; \
723                 fi \
724         done; \
725         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
726         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
727           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
728
729 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
730         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
731
732 testjit:
733         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
734
735 testaot:
736         @$(MAKE) AOT=1 runtest
737
738 testtrace:
739         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
740
741 testinterp:
742         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
743
744 testjitspeed: $(JITTEST_PROG) $(TESTBS)
745         for i in $(TESTBS); do  \
746                 echo $$i;       \
747                 time $(JITTEST_PROG) $$i;       \
748         done
749
750 test-iomap-regression: exists.cs
751         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
752         @echo "Testing exists.exe..."
753         @MONO_IOMAP=all $(RUNTIME) exists.exe
754
755 stresstest: $(STRESS_TESTS)
756         @failed=0; \
757         passed=0; \
758         failed_tests="";\
759         for i in $(STRESS_TESTS); do    \
760                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
761                 then \
762                         passed=`expr $${passed} + 1`; \
763                 else \
764                         if [ $$? = 2 ]; then break; fi; \
765                         failed=`expr $${failed} + 1`; \
766                         failed_tests="$${failed_tests} $$i"; \
767                 fi \
768         done; \
769         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
770         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
771           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
772
773 testbundle: console.exe
774         @echo "Testing mkbundle..."
775         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
776         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
777         @- rm -rf a.out
778
779 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
780 test-type-load: TestDriver.dll
781         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
782         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
783         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
784         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
785         @echo "Testing load-exception.exe..."
786         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
787
788
789 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs
790
791
792 #those are actually configurations, eg plain_sgen-descriptors.exe
793 #DISABLE_SGEN_TESTS =
794
795 SGEN_TESTS =    \
796         finalizer-wait.exe      \
797         critical-finalizers.exe \
798         sgen-descriptors.exe    \
799         sgen-gshared-vtype.exe  \
800         sgen-domain-unload.exe  \
801         sgen-weakref-stress.exe \
802         sgen-cementing-stress.exe       \
803         sgen-case-23400.exe
804
805 SGEN_CONFIGURATIONS =   \
806         "|plain"        \
807         "major=marksweep-par|ms-par"    \
808         "major=marksweep-conc|ms-conc"  \
809         "major=marksweep-conc,minor=split|ms-conc-split"        \
810         "minor=split|ms-split"  \
811         "minor=split,alloc-ratio=95|ms-split-95"
812
813 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
814 SGEN_BRIDGE_CONFIGURATIONS =    \
815         "|plain"        \
816         ",major=marksweep-conc|ms-conc" \
817         ",minor=split|ms-split"
818
819 sgen-regular-tests: $(SGEN_TESTS)
820         @failed=0; \
821         passed=0; \
822         failed_tests="";\
823         for test in $+; do      \
824                 echo "...$$test";       \
825                 for conf in $(SGEN_CONFIGURATIONS); do  \
826                         name=`echo $$conf | cut -d\| -f 2`;     \
827                         params=`echo $$conf | cut -d\| -f 1`;   \
828                         test_name="$${test}|$${name}";  \
829                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
830                         then \
831                                 passed=`expr $${passed} + 1`; \
832                         else \
833                                 if [ $$? = 2 ]; then break; fi; \
834                                 failed=`expr $${failed} + 1`; \
835                                 failed_tests="$${failed_tests} $$test_name"; \
836                         fi \
837                 done    \
838         done;   \
839         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
840         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
841           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
842
843 sgen-bridge-tests: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
844         @failed=0; \
845         passed=0; \
846         failed_tests="";\
847         for test in $+; do      \
848                 echo "...$$test";       \
849                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
850                         name=`echo $$conf | cut -d\| -f 2`;     \
851                         params=`echo $$conf | cut -d\| -f 1`;   \
852                         test_name="$${test}|$${name}";  \
853                         if MONO_GC_PARAMS="bridge=Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);      \
854                         then \
855                                 passed=`expr $${passed} + 1`; \
856                         else \
857                                 if [ $$? = 2 ]; then break; fi; \
858                                 failed=`expr $${failed} + 1`; \
859                                 failed_tests="$${failed_tests} $$test_name"; \
860                         fi \
861                 done    \
862         done;   \
863         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
864         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
865           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
866
867 sgen-tests: sgen-regular-tests sgen-bridge-tests
868
869
870 # Generated tests for runtime invoke
871 EXTRA_DIST += gen-runtime-invoke.cs
872 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
873         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
874         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
875
876 EXTRA_DIST += make-imt-test.cs
877 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
878         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
879         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
880
881 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
882 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
883         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
884 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
885         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
886
887 EXTRA_DIST += unhandled-exception-base-configuration.config
888 EXTRA_DIST += unhandled-exception-legacy-configuration.config
889 EXTRA_DIST += appdomain-unload.exe.config
890 EXTRA_DIST += unhandled-exception-test-case.2.cs
891 EXTRA_DIST += unhandled-exception-test-runner.2.cs
892 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
893         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
894 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
895         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
896 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
897         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
898 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
899         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
900         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
901         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
902         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
903 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
904         $(MCS) /debug unhandled-exception-test-case.1.cs
905 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
906         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
907 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
908         $(MCS) /debug unhandled-exception-test-case.2.cs
909 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
910         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
911 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
912         $(MCS) /debug unhandled-exception-test-runner.2.cs
913
914 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
915         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
916
917 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
918 bug-80307.exe: $(srcdir)/bug-80307.cs
919         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
920         cd $(top_builddir)/runtime && $(MAKE) test-support-files
921
922 EXTRA_DIST += bug-81673-interface.cs
923 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
924         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
925         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
926         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
927
928 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
929 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
930         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
931         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
932         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
933         rm -f bug-81691-a.dll
934 bug-81691.exe: bug-81691-b.dll
935
936 EXTRA_DIST += bug-81466-lib.il
937 bug-81466-lib.dll: bug-81466-lib.il
938         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
939 bug-81466.exe: bug-81466.il bug-81466-lib.dll
940         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
941
942 EXTRA_DIST += bug-324535-il.il
943 bug-324535-il.dll : bug-324535-il.il
944         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
945 bug-324535.exe : bug-324535.cs bug-324535-il.dll
946         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
947
948 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
949 custom-modifiers-lib.dll: custom-modifiers-lib.il
950         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
951 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
952         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
953
954 EXTRA_DIST += bug-382986-lib.cs
955 bug-382986-lib.dll: bug-382986-lib.cs
956         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
957 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
958         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
959
960 EXTRA_DIST += coreclr-security.cs
961
962 if MOONLIGHT
963 coreclr-security.exe : coreclr-security.cs
964         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
965
966 test-coreclr-security : coreclr-security.exe
967         @echo "Testing coreclr-security.exe..."
968         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
969 endif
970
971 EXTRA_DIST += generic-unboxing.2.il
972 generic-unboxing.2.dll : generic-unboxing.2.il
973         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
974
975 EXTRA_DIST += generic-boxing.2.il
976 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
977         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
978
979 EXTRA_DIST += generic-unbox.2.cs
980 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
981         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
982
983 EXTRA_DIST += generic-box.2.cs
984 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
985         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
986
987 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
988 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
989         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
990 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
991         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
992
993 bug-3903.exe: bug-3903.cs
994         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
995
996 gshared: test-generic-sharing
997
998 gshared-aot:
999         @$(MAKE) AOT=1 gshared
1000
1001 GSHARED_TESTS = \
1002                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1003                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1004                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1005                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1006                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1007                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1008                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1009                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1010                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1011                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1012                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1013                 generic-array-exc.2.exe generic-special.2.exe                   \
1014                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1015                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1016                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1017                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1018                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1019                 generic-constrained.2.exe bug-431413.2.exe                      \
1020                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1021                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1022                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1023                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1024                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1025                 bug-479763.2.exe generic-xdomain.2.exe                          \
1026                 generic-type-load-exception.2.exe bug-616463.exe        \
1027                 bug-1147.exe
1028
1029 test-generic-sharing-normal: $(GSHARED_TESTS)
1030         @for fn in $+ ; do      \
1031                 echo "Testing $$fn ...";        \
1032                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
1033                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1034                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1035                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1036                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1037         done
1038
1039 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1040         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1041
1042 test-generic-sharing:
1043         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1044
1045 EXTRA_DIST += async-exceptions.cs
1046 async-exceptions.exe : async-exceptions.cs
1047         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1048 test-async-exceptions : async-exceptions.exe
1049         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1050         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1051
1052 EXTRA_DIST += modules.cs modules-m1.cs
1053 modules-m1.netmodule: modules-m1.cs
1054         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1055 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1056         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1057
1058 # Useful if mono is compiled with --enable-shared=no
1059 patch-libtool:
1060         cp "../../libtool" .
1061         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1062         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1063         touch libtest.c
1064
1065 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected threadpool-in-processexit.cs threadpool-in-processexit.exe.stdout.expected
1066 test-process-exit:
1067         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1068         @echo "Testing bug-438454.exe..."
1069         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1070         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1071         @$(MCS) $(srcdir)/threadpool-in-processexit.cs -out:threadpool-in-processexit.exe
1072         @echo "Testing threadpool-in-processexit.exe..."
1073         @$(RUNTIME) threadpool-in-processexit.exe > threadpool-in-processexit.exe.stdout
1074         @diff -w threadpool-in-processexit.exe.stdout $(srcdir)/threadpool-in-processexit.exe.stdout.expected
1075
1076 OOM_TESTS =     \
1077         gc-oom-handling.exe     \
1078         gc-oom-handling2.exe
1079
1080
1081 test-oom: $(OOM_TESTS)
1082         @for fn in $+ ; do      \
1083                 echo "Testing $$fn ...";        \
1084                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1085                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1086                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1087         done
1088
1089
1090 noinst_LTLIBRARIES = libtest.la
1091
1092 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1093
1094 if HOST_WIN32
1095 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1096 # This shows up when compiling mono_test_marshal_delegate ()
1097 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1098 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1099 # can't find them. So we use --kill-at to remove the @ suffix as well.
1100 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1101 else
1102 libtest_la_LDFLAGS = -rpath `pwd`
1103 endif
1104 libtest_la_SOURCES = libtest.c
1105 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1106
1107 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat